non-thread safe php

Problems with the Windows version of XAMPP, questions, comments, and anything related.

non-thread safe php

Postby mrwonderfulone » 12. April 2010 20:43

is it possible to install a non-thread safe php in the latest xampp release (1.73)? Any instructions would be appreciated.

Motive is to work with the zend debugger which will only work with non-thread safe php for php 5.3
mrwonderfulone
 
Posts: 2
Joined: 10. June 2008 02:14

Re: non-thread safe php

Postby whuang83 » 13. September 2010 02:12

I got the same problem.
Hope someone can help on this.
whuang83
 
Posts: 5
Joined: 13. September 2010 01:54

Re: non-thread safe php

Postby JonB » 13. September 2010 20:53

First - XAMPP is a suite of programs, and some parts are what I would term 'critical' - I'd make that list Apache, PHP, MySQL and Perl, perhaps you could make a case for something else, but I can't think of what it would be. For those critical parts, 'installing a different/upgrading' any one of that list pretty much does not work. This is because there's so much configuration work with 'all the other parts'. You may as well build your own suite (or just install everything standalone and do the configuration work).

Based on my research of compilation issues, I believe the answer is no - at least with regard to using PHP in its default mode (which is as a DLL) that runs as part of httpd.exe. This is because of its reliance on Apache. XAMPP uses the Apache Software Foundation builds, and 'that' Apache build is Thread Safe.

AFAIK - Edit - not happening (you 'might' be able to build a CGI version of PHP (executable) that was not thread safe to run inside XAMPP), but I am not aware of anyone whom has done this. Edit - Explanation - I suspect that would be a pretty good sized task. You would need to really understand all the issues involved (I don't know what all of them are) but my 'guess list' is long. Most of these things break down on very technical issues. For instance, you will have to verify that all the extensions you wish to use will work with your new compilation. To be clear what I mean, on Windows, extensions are DLL's and to work they have to be compiled with the same compiler and compiler version as the calling executable. And, of course you get to create your own build of a custom php.ini. That means (likely) a BIG task/problem - mucho mucho work. I have other 'guesses', but this would appear to be the 'biggy' issue. :shock: (and upon researching the last paragraph here, I don't think it will work, as you won't be able to make mod_fcgi run) I'm 99.995% sure on this now (I just researched how FCGI works to maintain persistance).

viewtopic.php?f=16&t=39079

This last paragraph/piece is non-tested, but I'll tell you my suspicions. There is an included PHP as CGI exectable in the XAMPP package. Its php-cgi.exe, and as far as I can tell, its not widely used. However, as it uses (presumably) the same ext (extensions) you can presume it likely is also Thread Safe. There IS a php-fcgi.exe - but it won't work with XAMPP as its a VC9 compile and you have to be able to load 'fcgi' itself (its an Apache module 'mod_fcgi' also VC9).

If you really need to work with the newer Zend components - You might want to see if anyone has a Fast CGI Windows variant of Apache. Windows IIS 6 & 7 support FastCGI.

Google 'non-thread safe Apache' and 'apache 2.2 fcgi' for a look-see at the issues.

Good Luck
8)
User avatar
JonB
AF Moderator
 
Posts: 3210
Joined: 12. April 2010 16:41
Location: Land of the Blazing Sun
XAMPP Version: 1.8.3-2
Operating System: Windows XP/7 - Fedora 15 1.7.7

Re: non-thread safe php

Postby pascal.dls » 11. December 2013 05:42

Same here would love to have the option in choosing ts or nts please thanks
since most of us mainly use xampp in a development localhost environment ts is not that important
pascal.dls
 
Posts: 1
Joined: 11. December 2013 05:28
XAMPP Version: 5.5.19
Operating System: windows 8


Return to XAMPP for Windows

Who is online

Users browsing this forum: No registered users and 55 guests